package net.http.requestfield {
	
	import flash.utils.ByteArray;
	import flash.utils.IDataInput;
	import flash.utils.IDataOutput;
	import net.http.Request;
	
	/**
	 * Класс, представляющий поле в запросе, содержащее строковое значение
	 * 
	 * @author gloomyBrain
	 */
	public final class Parameter implements IByteableField {
		
		private var _name:String;
		private var _value:String;
		
		/**
		 * @param	name	Имя поля запроса
		 * @param	data	Строковое значение поля
		 */
		public function Parameter(name:String, value:String) {
			
			_value = value;
			_name = name;
			
		}
		
		/**
		 * Имя поля
		 */
		public function get name():String {
			return _name;
		}
		
		/**
		 * Значение поля
		 */
		public function get value():String {
			return _value;
		}
		
		/**
		 * Преобразует поле запроса в массив байт
		 * Порядок байт устанавливается в BIG_ENDIAN
		 */
		public function toBytes(storage:IDataOutput = null):IDataInput {
			
			if (!storage) storage = new ByteArray();
			
			storage.writeUTFBytes("Content-Disposition: form-data; name=\"" + _name + "\"");
			
			storage.writeUTFBytes(Request.LB);
			storage.writeUTFBytes(Request.LB);
			
			storage.writeUTFBytes(_value);
			
			storage.writeUTFBytes(Request.LB);
			
			return storage as IDataInput;
			
		}
		
	}

}